<?php

class M_deposit extends CI_Model {

    public $table = "at_cashdeposit";
    public $journal = "at_cdepjournal";
    public $account = "at_compaccountgl";
    public $reconcile = "at_bankreconcille";
    public $acc_gl = "am_accountgl";
    public $sub_type = "am_accountsubtype";
    public $branch = "am_branch";
    public $company = "am_company";
    public $period = "at_periodend";
    public $employee = "am_employee";
    public $department = "am_department";

    function get_all() {
        /* =========================lemparan parah dari custom.js untuk searching_data_transaksi===================== */
        $param = $this->input->post('param');
        /* ====================================end=================================================================== */

        /* =================================post dari find di kiri==================================================== */
        $Number = isset($param['txt_IDNumber']) ? $param['txt_IDNumber'] : '';
        $Desc = isset($param['txt_Description']) ? $param['txt_Description'] : '';

        $DateFrom = isset($param['txt_DateFrom']) ? $param['txt_DateFrom'] : '';
        $DateTo = isset($param['txt_DateTo']) ? $param['txt_DateTo'] : '';
        $TransStatus = isset($param['chk_TransStatus']) ? $param['chk_TransStatus'] : '';
        $BranchCode = isset($param['cmb_branch']) ? $param['cmb_branch'] : '';
        /* ============================================end============================================================ */

        /* ======================================scrol view 1-150======================================= */
        $page = ($this->input->post('page')) ? intval($this->input->post('page')) : 1;
        $rows = ($this->input->post('rows')) ? intval($this->input->post('rows')) : 150;

        $beginning = ($page - 1) * $rows;
        $end = $page * $rows;
        /* ============================================================================================== */

        /* ==========================================by session======================================================= */
        $sess_company = $this->session->userdata('company');
        $sess_branch = $this->session->userdata('branch');
        $sess_branch_status = $this->session->userdata('branch_status');
        /* =========================================================================================================== */

        $this->db->select('at_cashdeposit.CDepNumber, at_cashdeposit.CDepDate, at_cashdeposit.CDepTotalAmount, at_cashdeposit.CDepDesc, at_cashdeposit.TransStatus,at_cashdeposit.CreatedBy,am_employee.EmployeeName');
        $this->db->from($this->table);
        $this->db->join('am_branch', 'at_cashdeposit.BranchCode=am_branch.BranchCode', 'INNER');
        $this->db->join('am_employee', 'at_cashdeposit.CreatedBy=am_employee.EmployeeCode', 'LEFT');

        /* ===================================find by number dan desc========================================================= */
        if ($Number != "") {
            $this->db->like('at_cashdeposit.CDepNumber', $Number);
        }
        if ($Desc != "") {
            $this->db->like('at_cashdeposit.ADebtDesc', $Desc);
        }
        /* =============================================end=================================================================== */

        /* ===================================find by branch code========================================================= */
        /*
          get data dari  combobox find di view
         */
        if ($BranchCode != "") {
            $this->db->where('at_cashdeposit.BranchCode', $BranchCode);
        } else {
            /*
              inisialisasi untuk loading pertama page branch info
             */
            //----------------kondisi by company-------------------------------------//
            /*
              branch status 0 = HO
              branch status 1 = depo/branch
              jangan lupa sesion data di atas untuk setiap kondisi
              jangan lupa tambahin case when trans status
             */
            $this->db->where('at_cashdeposit.BranchCode', $sess_branch);
            //-----------------------end-------------------------------------------------//
        }
        /* =======================================================end======================================================== */

        /* =====================================================find by date================================================== */
        if ((($DateFrom != '') && ($DateTo != ''))) {
            if ($DateFrom <= $DateTo) {
                $this->db->where('at_cashdeposit.CDepDate >=', date("Y-m-d", strtotime($DateFrom)));
                $this->db->where('at_cashdeposit.CDepDate <=', date("Y-m-d", strtotime($DateTo)));
            }
        }
        /* ======================================================end=========================================================== */

        /* =====================================================find by status================================================== */
        if ($TransStatus != '') {
            $this->db->where_in('at_cashdeposit.TransStatus', $TransStatus);
        } else {
            /*
              trans status 0,1 adalah aktif
             */
            $this->db->where_in('at_cashdeposit.TransStatus', array(0, 1, 4, 5, 6, 7, 8));
        }
        /* =======================================================end======================================================== */

        /* ==============================================sort tabel asc========================================================== */
        $this->db->order_by($this->table . '.CDepNumber', 'ASC');
        $this->db->order_by($this->table . '.TransStatus', 'DESC');
        /* ===============================end================================================================================= */
        $this->db->limit($end, $beginning);

        $query = $this->db->get();
        return $query->result();
    }

    function get_all_to_print($data_filter) {
        /* =================================post dari find di kiri==================================================== */
        $BranchCode     = $data_filter['cmb_branch'];
        $Number         = $data_filter['txt_IDNumber'];
        $Desc           = $data_filter['txt_Description'];
        $DateFrom       = $data_filter['txt_DateFrom'];
        $DateTo         = $data_filter['txt_DateTo'];
        $TransStatus    = $data_filter['chk_TransStatus'];
        /* ============================================end============================================================ */

        /* ==========================================by session======================================================= */
        $sess_company = $this->session->userdata('company');
        $sess_branch = $this->session->userdata('branch');
        $sess_branch_status = $this->session->userdata('branch_status');
        /* =========================================================================================================== */

        $this->db->select('at_cashdeposit.CDepNumber, at_cashdeposit.CDepDate, at_cashdeposit.CDepTotalAmount, at_cashdeposit.CDepDesc, at_cashdeposit.TransStatus,at_cashdeposit.CreatedBy,am_employee.EmployeeName');
        $this->db->from($this->table);
        $this->db->join('am_branch', 'at_cashdeposit.BranchCode=am_branch.BranchCode', 'INNER');
        $this->db->join('am_employee', 'at_cashdeposit.CreatedBy=am_employee.EmployeeCode', 'LEFT');

        /* ===================================find by number dan desc========================================================= */
        if ($Number != "") {
            $this->db->like('at_cashdeposit.CDepNumber', $Number);
        }
        if ($Desc != "") {
            $this->db->like('at_cashdeposit.ADebtDesc', $Desc);
        }
        /* =============================================end=================================================================== */

        /* ===================================find by branch code========================================================= */
        /*
          get data dari  combobox find di view
         */
        if ($BranchCode != "") {
            $this->db->where('at_cashdeposit.BranchCode', $BranchCode);
        } else {
            /*
              inisialisasi untuk loading pertama page branch info
             */
            //----------------kondisi by company-------------------------------------//
            /*
              branch status 0 = HO
              branch status 1 = depo/branch
              jangan lupa sesion data di atas untuk setiap kondisi
              jangan lupa tambahin case when trans status
             */
            $this->db->where('at_cashdeposit.BranchCode', $sess_branch);
            //-----------------------end-------------------------------------------------//
        }
        /* =======================================================end======================================================== */

        /* =====================================================find by date================================================== */
        if ((($DateFrom != '') && ($DateTo != ''))) {
            if ($DateFrom <= $DateTo) {
                $this->db->where('at_cashdeposit.CDepDate >=', date("Y-m-d", strtotime($DateFrom)));
                $this->db->where('at_cashdeposit.CDepDate <=', date("Y-m-d", strtotime($DateTo)));
            }
        }
        /* ======================================================end=========================================================== */

        /* =====================================================find by status================================================== */
        if (!empty($TransStatus)) {
            $this->db->where_in('at_cashdeposit.TransStatus', $TransStatus);
        } else {
            /*
              trans status 0,1 adalah aktif
             */
            $this->db->where_in('at_cashdeposit.TransStatus', array(0, 1, 4, 5, 6, 7, 8));
        }
        /* =======================================================end======================================================== */

        /* ==============================================sort tabel asc========================================================== */
        $this->db->order_by($this->table . '.CDepNumber', 'ASC');
        $this->db->order_by($this->table . '.TransStatus', 'DESC');
        /* ===============================end================================================================================= */
        $query = $this->db->get();
        return $query->result();
    }

    //custom
    function get_coa_bank($replace_branch, $currency_idr, $currency_code) {
        $jobtitle = $this->session->userdata("jobtitle");
        //$BranchCode 	= $this->session->userdata('branch');
        $BranchStatus = $this->session->userdata('branch_status');

        $this->db->select('ag.AccountNumber, ag.AccountName, ag.CurrencyCode');
        $this->db->from($this->account . ' as ac');
        $this->db->join($this->acc_gl . ' as ag', 'ac.AccountNumber=ag.AccountNumber', 'inner');
        $this->db->join($this->branch . ' as br', 'ac.BranchCode=br.BranchCode', 'inner');
        $this->db->join($this->sub_type . ' as sub', 'ag.AccountSubTypeID=sub.AccountSubTypeID', 'inner');

        $this->db->where('ac.GLSaldoYears', date('Y'));
        $this->db->where('ac.BranchCode', $replace_branch);

        // if($currency_code != "IDR"){
        // 	$arry_currency = array($currency_idr,$currency_code);
        // 	$this->db->where_in('ag.CurrencyCode', $arry_currency);
        // }

        $this->db->where('ag.CurrencyCode', $currency_code);

        $this->db->where('sub.AccountTypeName', 'Bank');
        $this->db->where('ag.AccountChild', 1);
        $this->db->where('ac.TransStatus', 2);

        $query = $this->db->get();

        $result = $query->result();
        return json_encode($result);
    }

    function get_coa_bank_add($CompanyCode, $str_replace_branch, $currency_idr, $currency_code) {
        $jobtitle = $this->session->userdata("jobtitle");
        $BranchCode = $this->session->userdata('branch');
        $BranchStatus = $this->session->userdata('branch_status');

        $this->db->select('ag.AccountNumber, ag.AccountName, ag.CurrencyCode');
        $this->db->from($this->account . ' as ac');
        $this->db->join($this->acc_gl . ' as ag', 'ac.AccountNumber=ag.AccountNumber', 'inner');
        $this->db->join($this->branch . ' as br', 'ac.BranchCode=br.BranchCode', 'inner');
        $this->db->join($this->sub_type . ' as sub', 'ag.AccountSubTypeID=sub.AccountSubTypeID', 'inner');

        if ($this->session->userdata('jobtitle_status') != 0) {
            if ($BranchStatus == 0) {
                $this->db->where('ac.CompanyCode', $CompanyCode);
                $this->db->where('ac.GLSaldoYears', date('Y'));
                $this->db->where('br.BranchStatus', 0);
            } else {
                $this->db->where('ac.CompanyCode', $CompanyCode);
                $this->db->where('ac.BranchCode', $str_replace_branch);
                $this->db->where('ac.GLSaldoYears', date('Y'));
            }
        } else {
            $this->db->where('ac.GLSaldoYears', date('Y'));
            $this->db->where('ac.BranchCode', $str_replace_branch);
        }

        // if($currency_code != "IDR"){
        // 	$arry_currency = array($currency_idr,$currency_code);
        // 	// $arry_currency = array($currency_code);
        // 	$this->db->where_in('ag.CurrencyCode', $arry_currency);
        // }

        $this->db->where('ag.CurrencyCode', $currency_code);

        $this->db->where('sub.AccountTypeName', 'Bank');
        $this->db->where('ag.AccountChild', 1);
        $this->db->where('ac.TransStatus', 2);

        $query = $this->db->get();

        $result = $query->result();
        return json_encode($result);
    }

    function get_petty_cash_add($CompanyCode, $BranchCode) {
        $jobtitle = $this->session->userdata("jobtitle");
        $BranchStatus = $this->session->userdata('branch_status');

        $this->db->select('ag.AccountNumber, ag.AccountName, ag.CurrencyCode');
        $this->db->from($this->account . ' as ac');
        $this->db->join($this->acc_gl . ' as ag', 'ac.AccountNumber=ag.AccountNumber', 'inner');
        $this->db->join($this->branch . ' as br', 'ac.BranchCode=br.BranchCode', 'inner');
        $this->db->join($this->sub_type . ' as sub', 'ag.AccountSubTypeID=sub.AccountSubTypeID', 'inner');

        if ($BranchStatus == 0) {
            if ($this->session->userdata('jobtitle_status') != 0) {
                $this->db->where('ac.CompanyCode', $CompanyCode);
                $this->db->where('ac.BranchCode', $BranchCode);
                $this->db->where('ac.GLSaldoYears', date('Y'));
            } else {
                $this->db->where('ac.GLSaldoYears', date('Y'));
                $this->db->where('ac.BranchCode', $BranchCode);
            }
        } else {
            if ($this->session->userdata('jobtitle_status') != 0) {
                $this->db->where('ac.CompanyCode', $CompanyCode);
                $this->db->where('ac.BranchCode', $BranchCode);
                $this->db->where('ac.GLSaldoYears', date('Y'));
            } else {
                $this->db->where('ac.GLSaldoYears', date('Y'));
                $this->db->where('ac.BranchCode', $BranchCode);
            }
        }

        $this->db->where('sub.AccountTypeName', 'Petty Cash');
        $this->db->where('ag.AccountChild', 1);
        $this->db->where('ac.TransStatus', 2);

        $query = $this->db->get();

        $result = $query->result();
        return json_encode($result);
    }

    function get_petty_cash($CompanyCode, $replace_branch) {
        $jobtitle = $this->session->userdata("jobtitle");
        $BranchStatus = $this->session->userdata('branch_status');

        $this->db->select('ag.AccountNumber, ag.AccountName, ag.CurrencyCode');
        $this->db->from($this->account . ' as ac');
        $this->db->join($this->acc_gl . ' as ag', 'ac.AccountNumber=ag.AccountNumber', 'inner');
        $this->db->join($this->branch . ' as br', 'ac.BranchCode=br.BranchCode', 'inner');
        $this->db->join($this->sub_type . ' as sub', 'ag.AccountSubTypeID=sub.AccountSubTypeID', 'inner');

        $this->db->where('ac.GLSaldoYears', date('Y'));
        $this->db->where('ac.BranchCode', $replace_branch);

        $this->db->where('sub.AccountTypeName', 'Petty Cash');
        $this->db->where('ag.AccountChild', 1);
        $this->db->where('ag.TransStatus', 2);

        $query = $this->db->get();

        $result = $query->result();
        return json_encode($result);
    }

    //end

    function count_deposit_number($bulan, $cek_tahun, $BranchCode) {
        $this->db->select('*');
        $this->db->from('at_cashdeposit');
        $this->db->where('MONTH(CDepDate)', $bulan);
        $this->db->where('YEAR(CDepDate)', $cek_tahun);
        $this->db->where('BranchCode', $BranchCode);
        return $this->db->get()->num_rows();
    }

    function get_last_deposit_number($BranchCode) {
        $qty = "SELECT MAX(CDepNumber) as CDepNumber FROM at_cashdeposit WHERE BranchCode='$BranchCode'";
        return $this->db->query($qty)->result();
    }

    /* ======================penomeran transaksi new======================================================= */

    function check_code_exist($new_jc_number) {
        $query = $this->db->get_where($this->table, array('CDepNumber' => $new_jc_number), 1, 0);

        if ($query->num_rows() > 0) {
            return TRUE;
        } else {
            return FALSE;
        }
    }

    function create_dep_number($date = '') {
        $branch = $this->session->userdata('branch');

        if ($date != '') {
            $month = date('m', strtotime($date));
            $year = date('y', strtotime($date));
        } else {
            $month = date('m');
            $year = date('y');
        }

        $jc_number = $branch . "/" . $month . $year . "CD/";

        $this->db->_protect_identifiers = false;
        $this->db->select('(CASE 
                              WHEN MAX(CONVERT(SUBSTR(CDepNumber, -3),signed)) IS NULL then 1
                              ELSE MAX(CONVERT(SUBSTR(CDepNumber, -3),signed)) + 1 END) as New_Number');
        $this->db->like('CDepNumber', $jc_number);
        $query = $this->db->get($this->table);
        $this->db->_protect_identifiers = true;

        $num = $query->row()->New_Number;
        $long = strlen($num);

        if ($long == 1) {
            $number = '00' . $num;
        } elseif ($long == 2) {
            $number = '0' . $num;
        } else {
            $number = $num;
        }

        $new_jc_number = $jc_number . $number;

        while ($this->check_code_exist($new_jc_number)) {
            $num++;
            $long = strlen($num);

            if ($long == 1) {
                $number = '00' . $num;
            } elseif ($long == 2) {
                $number = '0' . $num;
            } else {
                $number = $num;
            }

            $new_jc_number = $jc_number . $number;
        }

        return $new_jc_number;
    }

    /* ==============================================================end================================= */

    function insert_group($data_deposit) {
        $this->db->insert($this->table, $data_deposit);
    }

    function insert_journal($journal_data) {
        $this->db->insert($this->journal, $journal_data);
    }

    function update_group($data_deposit, $txt_deposit_no) {
        $this->db->where('CDepNumber', $txt_deposit_no);
        $this->db->update($this->table, $data_deposit);
    }

    function delete_journal($txt_deposit_no) {
        $this->db->where('CDepNumber', $txt_deposit_no);
        $this->db->delete($this->journal);
    }

    function update_journal_appfinis($stat_appfinished, $deposit_number) {
        $this->db->where('CDepNumber', $deposit_number);
        $this->db->update('at_cdepjournal', $stat_appfinished);
    }

    function update_journal_debit_deposit($journal_debet, $txt_deposit_no) {
        $this->db->where('CDepNumber', $txt_deposit_no);
        $this->db->where('CDepSaldoCredit', 0);
        $this->db->update('at_cdepjournal', $journal_debet);
    }

    function update_journal_credit_deposit($journal_credit, $txt_deposit_no) {
        $this->db->where('CDepNumber', $txt_deposit_no);
        $this->db->where('CDepSaldoDebet', 0);
        $this->db->update('at_cdepjournal', $journal_credit);
    }

    function cek_trans_status($id) {
        $this->db->select('TransStatus');
        $this->db->from('at_cashdeposit');
        $this->db->where('CDepNumber', $id);
        $query = $this->db->get();

        if ($query->num_rows() > 0) {
            foreach ($query->result() as $row) {
                $TransStatus = $row->TransStatus;
            }
            return $TransStatus;
        } else {
            return FALSE;
        }
    }

    function cek_app_mgr($id) {
        $this->db->select('AppLevel1Status');
        $this->db->from('at_cashdeposit');
        $this->db->where('CDepNumber', $id);
        $query = $this->db->get();

        if ($query->num_rows() > 0) {
            foreach ($query->result() as $row) {
                $AppLevel1Status = $row->AppLevel1Status;
            }
            return $AppLevel1Status;
        } else {
            return FALSE;
        }
    }

    function pembatalan_transaksi($id, $data) {
        $this->db->where('CDepNumber', $id);
        $this->db->update($this->table, $data);

        if ($this->db->trans_status() === FALSE) {
            $this->db->trans_rollback();
            return 0;
        } else {
            //$this->db->trans_commit();
            return 1;
        }
    }

    function suspend_data($data, $id) {
        $this->db->update($this->table, $data, array('CDepNumber' => $id));
    }

    function get_detail($id) {
        $this->db->select('gr.*,em.DepartmentCode');
        $this->db->from($this->table . ' as gr');
        $this->db->join($this->employee . ' as em', 'em.EmployeeCode=gr.CreatedBy', 'inner');
        $this->db->where('gr.CDepNumber', $id);
        $query = $this->db->get();

        if ($query->num_rows() > 0) {
            return $query->row();
        } else {
            return false;
        }
    }

    function get_account_name_bank_payment($BankPayment) {
        $this->db->select('am_accountgl.AccountName');
        $this->db->from('am_accountgl');
        $this->db->join('at_compaccountgl', 'am_accountgl.AccountNumber=at_compaccountgl.AccountNumber');
        $this->db->where('am_accountgl.AccountNumber', $BankPayment);
        $query = $this->db->get();

        if ($query->num_rows() > 0) {
            foreach ($query->result() as $row) {
                $AccountName = $row->AccountName;
            }
            return $AccountName;
        } else {
            $AccountName = 0;
            return $AccountName;
        }
    }

    function get_account_name_bank_receipt($BankReceipt) {
        $this->db->select('am_accountgl.AccountName');
        $this->db->from('am_accountgl');
        $this->db->join('at_compaccountgl', 'am_accountgl.AccountNumber=at_compaccountgl.AccountNumber');
        $this->db->where('am_accountgl.AccountNumber', $BankReceipt);
        $query = $this->db->get();

        if ($query->num_rows() > 0) {
            foreach ($query->result() as $row) {
                $AccountName = $row->AccountName;
            }
            return $AccountName;
        } else {
            $AccountName = 0;
            return $AccountName;
        }
    }

    function get_date_journal_deposit($deposit_number) {
        $this->db->select('*, am_company.CompanyName');
        $this->db->from($this->table);
        $this->db->join('am_branch', 'am_branch.BranchCode=at_cashdeposit.BranchCode');
        $this->db->join('am_company', 'am_company.CompanyCode=am_branch.CompanyCode');
        $this->db->where('CDepNumber', $deposit_number);
        $query = $this->db->get();

        $result = $query->result();
        return json_encode($result);
    }

    function get_branch($deposit_number) {
        $this->db->select('at_cashdeposit.BranchCode');
        $this->db->from($this->table);
        $this->db->join('am_branch', 'am_branch.BranchCode=at_cashdeposit.BranchCode');
        $this->db->join('am_company', 'am_company.CompanyCode=am_branch.CompanyCode');
        $this->db->where('CDepNumber', $deposit_number);
        $query = $this->db->get();

        $result = $query->row();
        return $result;
    }

    function get_all_journal_deposit($deposit_number, $branch) {
        $this->db->select('am_accountgl.AccountNumber, am_accountgl.AccountName, at_cdepjournal.CDepSaldoCredit, at_cdepjournal.AmountCurrency, 
						   at_cdepjournal.CDepSaldoDebet, at_cdepjournal.CDepDesc, at_cdepjournal.CDepNumber');
        $this->db->from('at_compaccountgl');
        $this->db->join('at_cdepjournal', 'at_compaccountgl.AccountNumber=at_cdepjournal.CDepAccountNumber');
        $this->db->join('am_accountgl', 'at_compaccountgl.AccountNumber=am_accountgl.AccountNumber');

        $this->db->where('at_compaccountgl.GLSaldoYears', date('Y'));
        $this->db->where('at_compaccountgl.BranchCode', $branch);

        $this->db->where('at_cdepjournal.CDepNumber', $deposit_number);
        $query = $this->db->get();

        $result = $query->result();
        return json_encode($result);
    }

    function update_approved_data($data, $deposit_number) {
        $this->db->where('CDepNumber', $deposit_number);
        return $this->db->update($this->table, $data);
    }

    function cek_app($deposit_number) {
        $this->db->select('AppLevel1Status');
        $this->db->from('at_cashdeposit');
        $this->db->where('CDepNumber', $deposit_number);
        $this->db->where('AppLevel1Status', 1);
        $query = $this->db->get();

        if ($query->num_rows() > 0) {
            foreach ($query->result() as $row) {
                $app = 1;
            }
            return $app;
        } else {
            $app = 0;
            return $app;
        }
    }

    function cek_status_app_mgr($deposit_number) {
        $this->db->select('AppLevel1Status');
        $this->db->from('at_cashdeposit');
        $this->db->where('CDepNumber', $deposit_number);
        $this->db->where('AppLevel1Status', 1);
        $query = $this->db->get();

        if ($query->num_rows() > 0) {
            foreach ($query->result() as $row) {
                $AppLevel1Status = $row->AppLevel1Status;
            }
            return $AppLevel1Status;
        } else {
            return FALSE;
        }
    }

    function cek_status_app_dir($deposit_number) {
        $this->db->select('AppLevel2Status');
        $this->db->from('at_cashdeposit');
        $this->db->where('CDepNumber', $deposit_number);
        $this->db->where('AppLevel2Status', 1);
        $query = $this->db->get();

        if ($query->num_rows() > 0) {
            foreach ($query->result() as $row) {
                $AppLevel2Status = $row->AppLevel2Status;
            }
            return $AppLevel2Status;
        } else {
            return FALSE;
        }
    }

    function status_finished($app_finished, $deposit_number) {
        $this->db->where('CDepNumber', $deposit_number);
        return $this->db->update('at_cashdeposit', $app_finished);
    }

    function update_to_reverse_deposit($txt_deposit_no, $data_deposit) {
        $this->db->where('CDepNumber', $txt_deposit_no);
        $this->db->update($this->table, $data_deposit);
    }

    function get_nm_created($txt_deposit_no) {
        $this->db->select('am_emp.EmployeeName as nm_prepared,am_mng.EmployeeName as nm_manager');
        $this->db->from($this->table . ' as at_dep');
        $this->db->join('am_employee as am_emp', 'at_dep.CreatedBy=am_emp.EmployeeCode', 'LEFT');
        $this->db->join('am_employee as am_mng', 'at_dep.AppLevel1Code=am_mng.EmployeeCode', 'LEFT');
        $this->db->where('CDepNumber', $txt_deposit_no);
        $query = $this->db->get()->result_array();

        if (count($query) > 0) {
            $result = $query[0];
        } else {
            $result = '';
        }

        return $result;
    }

    function get_barchname($BranchCode) {
        $this->db->select('BranchName,BranchAddress');
        $this->db->from('am_branch');
        $this->db->where('BranchCode', $BranchCode);
        $query = $this->db->get()->result_array();
        if (count($query) > 0) {
            $nmBranch = $query[0];
            return $nmBranch;
        } else {
            $nmBranch = array('BranchName' => '', 'BranchAddress' => '');
            return $nmBranch;
        }
    }

    function delete_reconcile($TransNumber) {
        $this->db->where('TransNumber', $TransNumber);
        $this->db->delete($this->reconcile);
    }

    function check_period_end($periodend) {
        $this->db->select('PeriodEnd');
        $this->db->from($this->period);
        $this->db->where('PeriodEnd', $periodend);

        $query = $this->db->get()->result_array();

        if (count($query) > 0) {
            return true;
        } else {
            return false;
        }
    }

    function get_company_by_branch($sess_branch) {
        $this->db->select('CompanyName,BranchName');
        $this->db->from($this->branch . ' as br');
        $this->db->join($this->company . ' as cp', 'cp.CompanyCode = br.CompanyCode', 'inner');
        $this->db->where('br.BranchCode', $sess_branch);
        $query = $this->db->get();
        return $query->row();
    }

    function insert_transsaction($trans_data) {

        $this->db->trans_start();

        /* ================= insert group transaction ============================== */
        $this->insert_group($trans_data['insert_group']['data']);

        for ($x = 0; $x < count($trans_data['insert_journal']['data']); $x++) {
            $this->insert_journal($trans_data['insert_journal']['data'][$x]);
        }

        $this->db->trans_complete();

        if ($this->db->trans_status() === FALSE) {
            return false;
        } else {
            return true;
        }
    }

    function update_transsaction($trans_data) {

        $this->db->trans_start();

        $this->update_group($trans_data['update_group']['data'], $trans_data['update_group']['TransNumber']);

        $this->delete_journal($trans_data['delete_journal']['TransNumber']);

        for ($x = 0; $x < count($trans_data['insert_journal']['data']); $x++) {
            $this->insert_journal($trans_data['insert_journal']['data'][$x]);
        }

        $this->db->trans_complete();

        if ($this->db->trans_status() === FALSE) {
            return false;
        } else {
            return true;
        }
    }

    function approve_transsaction($trans_data) {

        $this->db->trans_start();

        $this->update_approved_data($trans_data['approve_data']['data'], $trans_data['approve_data']['TransNumber']);

        $this->db->trans_complete();

        if ($this->db->trans_status() === false) {
            return false;
        } else {
            return true;
        }
    }

    function suspend_transsaction($trans_data) {

        $this->db->trans_start();

        $this->suspend_data($trans_data['suspend_data']['data'], $trans_data['suspend_data']['TransNumber']);

        $this->db->trans_complete();

        if ($this->db->trans_status() === FALSE) {
            return false;
        } else {
            return true;
        }
    }

    function reverse_transsaction($trans_data) {

        $this->db->trans_start();

        $this->update_to_reverse_deposit($trans_data['reverse_data']['TransNumber'], $trans_data['reverse_data']['data']);
        $this->delete_reconcile($trans_data['delete_reconcile']['TransNumber']);

        $this->db->trans_complete();

        if ($this->db->trans_status() === FALSE) {
            return false;
        } else {
            return true;
        }
    }

}
